tinymce.PluginManager.add('bdmap', function(editor, url) {
    var pluginName='百度地图';
    var baseURL=tinymce.baseURL;
    var iframe1 = baseURL+'/plugins/bdmap/map.html';
    var bdmap_width = function (editor) {
        return editor.getParam('bdmap_width', 560);
    };
    var bdmap_height = function (editor) {
        return editor.getParam('bdmap_height', 362);
    };
    window.tinymceLng='';
    window.tinymceLat='';
    var openDialog = function() {
        return editor.windowManager.openUrl({
            title: pluginName,
            size: 'large',
            //width: 800,
            //height: 500,
            url:iframe1,
            buttons: [
                {
                    type: 'cancel',
                    text: 'Close'
                },
                {
                    type: 'custom',
                    text: 'Save',
                    name: 'save',
                    primary: true
                },
            ],
            onAction: function (api, details) {
                switch (details.name) {
                    case 'save':
                        html='<iframe src="'+baseURL+'/plugins/bdmap/bd.html?center='+tinymceLng+'%2C'+tinymceLat+'&zoom=14&width='+(bdmap_width(editor)-2)+'&height='+(bdmap_height(editor)-2)+'" frameborder="0" style="width:'+bdmap_width(editor)+'px;height:'+bdmap_height(editor)+'px;">';
                        editor.insertContent(html);
                        api.close();
                        break;
                    default:
                        break;
                }
                
            }
        });
    };

    editor.ui.registry.getAll().icons.bdmap || editor.ui.registry.addIcon('bdmap','<img src="'+baseURL+'/plugins/bdmap/ico.gif">');
    
    editor.ui.registry.addButton('bdmap', {
        icon: 'bdmap',
        tooltip: pluginName,
        onAction: function() {
            openDialog();
        }
    });
    editor.ui.registry.addMenuItem('bdmap', {
		icon: 'bdmap',
        text: pluginName,
        onAction: function() {
            openDialog();
        }
    });
    return {
        getMetadata: function() {
            return  {
                name: pluginName,
                url: "http://tinymce.ax-z.cn/more-plugins/bdmap.php",
            };
        }
    };
});
